﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace Post9216Sample
{
    public partial class Form1 : Form
    {
        private RotationProjection rotateProjection;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.Meter;
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);


            InMemoryFeatureLayer inMemoryLayer = new InMemoryFeatureLayer();

            BaseShape baseShape1 = BaseShape.CreateShapeFromWellKnownData("LINESTRING(-180 0,180 0)");
            baseShape1.Id = "Line";
            Feature lineFeature1 = new Feature(baseShape1);
            inMemoryLayer.InternalFeatures.Add("Line1", lineFeature1);

            BaseShape baseShape2 = BaseShape.CreateShapeFromWellKnownData("LINESTRING(0 83,0 -90.0)");
            baseShape2.Id = "Line";
            Feature lineFeature2 = new Feature(baseShape2);
            inMemoryLayer.InternalFeatures.Add("Line2", lineFeature2);

            inMemoryLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle.OuterPen = new GeoPen(GeoColor.FromArgb(200, GeoColor.StandardColors.Red), 5);
            inMemoryLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            rotateProjection = new RotationProjection();
            inMemoryLayer.FeatureSource.Projection = rotateProjection;

            LayerOverlay staticOverlay = new LayerOverlay();
            staticOverlay.Layers.Add("InMemoryFeatureLayer", inMemoryLayer);


            LayerOverlay worldOverlay = new LayerOverlay();
            worldOverlay.Layers.Add("WorldLayer", inMemoryLayer);
            winformsMap1.Overlays.Add("WorldOverlay", worldOverlay);


            winformsMap1.ZoomLevelSnapping = ZoomLevelSnappingMode.None;
            winformsMap1.CurrentExtent = rotateProjection.GetUpdatedExtent(new RectangleShape(-180.0, 83.0, 180.0, -90.0));

            winformsMap1.Refresh();
        }

        private void btnRotate_Click(object sender, EventArgs e)
        {
            rotateProjection.Angle += 20;
            winformsMap1.CurrentExtent = rotateProjection.GetUpdatedExtent(winformsMap1.CurrentExtent);

            winformsMap1.Refresh(winformsMap1.Overlays["WorldOverlay"]);
        }
    }
}
